{
Data Criao: 27/06/08
Empresa: Pacto Solues Tecnolgicas - (62)-3251-5820
Analista/Programador: Ulisses Silva de Souza
}

unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ScktComp, jpeg;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    edtArquivo: TEdit;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Servidor: TServerSocket;
    memoCarga: TMemo;
    Label2: TLabel;
    btnAtivarServ: TButton;
    Image1: TImage;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ServidorClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServidorClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServidorClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnAtivarServClick(Sender: TObject);
  private
    pvlConexoes:TStringList;  
    function carga(pPos :String; prIndex:integer):integer;
    function enviarProgramaTerminal(prStr:string; prIndex:integer):boolean;    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edtArquivo.Text := OpenDialog1.FileName;
end;

procedure TForm1.ServidorClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
 IDConexao, posPont: ^byte;
 lista : Tlist;
 xiIndex:integer;
begin
  xiIndex := pvlConexoes.IndexOf(Socket.RemoteAddress);
  if xiIndex >= 0 then
  begin
    posPont := pointer(pvlConexoes.Objects[xiIndex]);
    pvlConexoes.Delete(xiIndex);
    Dispose(posPont);
    Servidor.Socket.Connections[xiIndex].Close;
  end;
  New(IDConexao);
  Socket.Data := IDConexao;
  pvlConexoes.AddObject(Socket.RemoteAddress,Socket.Data);

end;

procedure TForm1.ServidorClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  xiIndex:integer;
  posPont: ^byte;
begin
  xiIndex := pvlConexoes.IndexOf(Socket.RemoteAddress);
  if xiIndex >= 0 then
  begin
    posPont := pointer(pvlConexoes.Objects[xiIndex]);
    pvlConexoes.Delete(xiIndex);
    Dispose(posPont);
  end;
end;

procedure TForm1.ServidorClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  IdConexao, i: Integer;
  Msg,
  xsIp: string;
begin
  xsIp := Socket.RemoteAddress;
  Msg := socket.ReceiveText;
  IdConexao := pvlConexoes.IndexOf(xsIp);
  sleep(10);
  if not enviarProgramaTerminal(Msg,IdConexao) then
  begin
    //ShowMessage('Programa Enviado com sucesso.');
    // TratarMensagemRecebida(Msg);
    // tratar aqui as mensagem recebidas do programa que vc enviou para o micro-Terminal.
    Servidor.Socket.Connections[IdConexao].SendText(Chr(2) + 'Liberada!       ' + Chr(3));
  end;
end;

function TForm1.carga(pPos :String; prIndex:integer):integer;
var
   sSql: String;
   INTCanal: real;
   iReg, i, iBytesRead: Integer;
   LinhaDoARQ :String;
   lTam, HandleArq: integer;
   sarq, MYCHAR2 :String;
   MYCHAR: PChar;
   iPos, IdConexao:Integer;
   xfArquivo:file;
   cItemChar:Currency;
begin
  sarq := edtArquivo.Text ;
  if not FileExists(sarq) then
  begin
    Messagebox(Application.Handle, Pchar('Arquivo .tro no encontrado !'), 'erro', MB_OK + MB_ICONERROR);
    exit;
  end;
  iPos := strToInt(pPos);
  try
    HandleArq := FileOpen(sarq, fmOpenRead);
    lTam := FileSeek(HandleArq,0,2);
    FileSeek(HandleArq,0,0);
    MYCHAR := PChar(AllocMem(lTam + 1));

    iBytesRead := FileRead(HandleArq, MYCHAR^, lTam);
    FileClose(HandleArq);

    MYCHAR2 := '';
    for i := 0 to iBytesRead-1 do
      MYCHAR2 := MYCHAR2 + MYCHAR[i];


    cItemChar := lTam / 256;
    if trunc(cItemChar) <> cItemChar then
      cItemChar := trunc(cItemChar) + 1;

    iPos := iPos - 1;

    MYCHAR2 := copy(MYCHAR2, (iPos * 256) + 1, 256);
    while Length(MYCHAR2) <> 256 do
       MYCHAR2 := MYCHAR2 + Chr(0);

    inc(iPos);
    if iPos = cItemChar Then
      Servidor.Socket.Connections[prIndex].SendText(Chr(2) + Chr(6) + Chr(strToInt(pPos)) + MYCHAR2 + Chr(3))
    else
      Servidor.Socket.Connections[prIndex].SendText(Chr(2) + Chr(5) + Chr(strToInt(pPos)) + MYCHAR2 + Chr(3));
  finally
    freeMem(MYCHAR);
  end;
end;


function TForm1.enviarProgramaTerminal(prStr: string;
  prIndex: integer): boolean;
begin
  result := true;
  if (prStr[1] = Chr(5)) or (prStr[2] = Chr(5)) then
  begin
    if prStr[1] = Chr(5) then
    begin
      memoCarga.Lines.Add(Chr(13) + Chr(10) + FormatCurr('000', prIndex) + ':Solicitao de Carga ' + intToStr(ord(prStr[2])));
      carga(intToStr(ord(prStr[2])), prIndex);
    end
    else
    begin
      memoCarga.lines.Add(Chr(13) + Chr(10) + FormatCurr('000',prIndex) + ':Solicitao de Carga ' + intToStr(ord(prStr[3])));
      carga(intToStr(ord(prStr[3])), prIndex);
    end;
  end
  else
    result := false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:integer;
  pont: ^byte;
begin
  Servidor.Active := false;
  for i := pvlConexoes.Count -1 downto 0 do
  begin
    pont := pointer(pvlConexoes.Objects[i]);
    pvlConexoes.Delete(i);
    Servidor.Socket.Disconnect(i);
    Dispose(pont);
  end;
  FreeAndNil(pvlConexoes);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  pvlConexoes := TStringList.Create;
end;

procedure TForm1.btnAtivarServClick(Sender: TObject);
begin
  if not FileExists(edtArquivo.Text) then
    Messagebox(Application.Handle, Pchar('Arquivo .tro no encontrado !'), 'erro', MB_OK + MB_ICONERROR)
  else
  begin
    btnAtivarServ.Caption := 'Aguarde enquanto o sistema envia a carga...';
    Servidor.Active := true;
  end;
end;

end.
